module.exports = {
  'mmm': {
    'title': 'MMM',
    'shortTitle': 'MMM',
    //'timePeriod': '',
    'endpoint': 'http://ldf.fi/mmm-cidoc/sparql',
    //'endpoint': 'http://localhost:3050/ds/sparql',
    'countQuery': `
      PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
      PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
      PREFIX foaf: <http://xmlns.com/foaf/0.1/>
      PREFIX dct: <http://purl.org/dc/terms/>
      PREFIX frbroo: <http://erlangen-crm.org/efrbroo/>
      PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
      PREFIX wgs84: <http://www.w3.org/2003/01/geo/wgs84_pos#>
      PREFIX mmm: <http://ldf.fi/mmm/>
      PREFIX mmm-schema: <http://ldf.fi/mmm/schema/>
      PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
      PREFIX sdbm: <https://sdbm.library.upenn.edu/>
      SELECT (COUNT(DISTINCT ?id) as ?count)
      WHERE {
        <FILTER>
        ?id a  frbroo:F4_Manifestation_Singleton .
      }
      `,
    'manuscriptQuery': `
      PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
      PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
      PREFIX foaf: <http://xmlns.com/foaf/0.1/>
      PREFIX dct: <http://purl.org/dc/terms/>
      PREFIX frbroo: <http://erlangen-crm.org/efrbroo/>
      PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
      PREFIX wgs84: <http://www.w3.org/2003/01/geo/wgs84_pos#>
      PREFIX mmm: <http://ldf.fi/mmm/>
      PREFIX mmm-schema: <http://ldf.fi/mmm/schema/>
      PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
      PREFIX sdbm: <https://sdbm.library.upenn.edu/>
      PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
      SELECT *
      WHERE {
        {
          SELECT DISTINCT ?id {
            <FILTER>
            ?id a frbroo:F4_Manifestation_Singleton .
            ?id <ORDER_BY_PREDICATE> ?orderBy .
          }
          ORDER BY (!BOUND(?orderBy)) <SORT_DIRECTION>(?orderBy)
          <PAGE>
        }
        FILTER(BOUND(?id))
        ?id skos:prefLabel ?prefLabel .
        {
          ?id dct:source ?source__id .
          ?source__id skos:prefLabel ?source__prefLabel .
          OPTIONAL { ?id mmm-schema:data_provider_url ?source__dataProviderUrl }
        }
        UNION
        {
          #?id crm:P128_carries/^frbroo:R17_created/frbroo:R19_created_a_realisation_of/^frbroo:R16_initiated ?workConception .
          #?workConception mmm-schema:carried_out_by_as_author ?author__id .
          ?id mmm-schema:manuscript_author ?author__id .
          ?author__id skos:prefLabel ?author__prefLabel .
          OPTIONAL { ?author__id mmm-schema:data_provider_url ?author__dataProviderUrl }
        }
        UNION
        {
          ?production crm:P108_has_produced ?id .
          ?production crm:P4_has_time-span ?timespan .
          ?timespan skos:prefLabel ?timespan__id .
          OPTIONAL { ?timespan crm:P79_beginning_is_qualified_by ?timespan__start }
          OPTIONAL { ?timespan crm:P80_end_is_qualified_by ?timespan__end }
          BIND (?timespan__id AS ?timespan__prefLabel)
        }
        UNION
        {
          ?production crm:P108_has_produced ?id .
          ?production crm:P7_took_place_at ?productionPlace__id .
          ?productionPlace__id skos:prefLabel ?productionPlace__prefLabel .
          OPTIONAL { ?productionPlace__id mmm-schema:data_provider_url ?productionPlace__dataProviderUrl }
          # FILTER NOT EXISTS {
          #   ?production crm:P7_took_place_at ?productionPlace__id2 .
          #   ?productionPlace__id2 crm:P89_falls_within+ ?productionPlace__id .
          # }
        }
        UNION
        {
          ?id crm:P51_has_former_or_current_owner ?owner__id .
          ?owner__id skos:prefLabel ?owner__prefLabel .
          OPTIONAL { ?owner__id mmm-schema:data_provider_url ?owner__dataProviderUrl }
          OPTIONAL {
            [] rdf:subject ?id ;
              rdf:predicate crm:P51_has_former_or_current_owner ;
              rdf:object ?owner__id ;
              mmm-schema:order ?order .
            BIND(xsd:integer(?order) + 1 AS ?owner__order)
          }
        }
        UNION
        {
          ?id crm:P128_carries ?expression .
          ?expression crm:P72_has_language ?language .
        }
        UNION
        {
          ?event__id crm:P24_transferred_title_of|mmm-schema:observed_manuscript ?id .
          ?event__id a ?event__type .
          OPTIONAL { ?event__id skos:prefLabel ?event__prefLabel . }
          OPTIONAL { ?event__id crm:P4_has_time-span|mmm-schema:observed_time-span ?event__date. }
          OPTIONAL { ?event__id crm:P7_took_place_at|mmm-schema:observed_location ?event__place. }
          OPTIONAL { ?event__id  mmm-schema:data_provider_url ?event__dataProviderUrl }
        }
      }
      `,
    'productionPlacesQuery': `
      PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
      PREFIX wgs84: <http://www.w3.org/2003/01/geo/wgs84_pos#>
      PREFIX dct: <http://purl.org/dc/terms/>
      PREFIX owl: <http://www.w3.org/2002/07/owl#>
      PREFIX frbroo: <http://erlangen-crm.org/efrbroo/>
      PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
      PREFIX mmm-schema: <http://ldf.fi/mmm/schema/>
      SELECT ?id ?lat ?long ?prefLabel ?source ?dataProviderUrl
      (COUNT(DISTINCT ?manuscript) as ?instanceCount)
      WHERE {
        <FILTER>
        ?manuscript ^crm:P108_has_produced/crm:P7_took_place_at ?id .
        ?id skos:prefLabel ?prefLabel .
        ?id dct:source ?source .
        OPTIONAL { ?id mmm-schema:data_provider_url ?dataProviderUrl }
        OPTIONAL {
          ?id wgs84:lat ?lat ;
              wgs84:long ?long .
        }
      }
      GROUP BY ?id ?lat ?long ?prefLabel ?source ?dataProviderUrl
        `,
    'allPlacesQuery': `
      PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
      PREFIX wgs84: <http://www.w3.org/2003/01/geo/wgs84_pos#>
      PREFIX dct: <http://purl.org/dc/terms/>
      PREFIX owl: <http://www.w3.org/2002/07/owl#>
      PREFIX frbroo: <http://erlangen-crm.org/efrbroo/>
      PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
      PREFIX mmm-schema: <http://ldf.fi/mmm/schema/>
      PREFIX gvp: <http://vocab.getty.edu/ontology#>
      SELECT *
      WHERE {
        ?id a crm:E53_Place .
        ?id skos:prefLabel ?prefLabel .
        ?id dct:source ?source .
        OPTIONAL {
          ?id wgs84:lat ?lat ;
              wgs84:long ?long .
        }
        OPTIONAL {
          ?id gvp:broaderPreferred ?parent__id .
          ?parent__id skos:prefLabe ?parent__prefLabel .
        }
        OPTIONAL { ?id gvp:placeTypePreferred ?placeType  }
        OPTIONAL { ?id skos:altLabel ?altLabel  }
        OPTIONAL { ?id owl:sameAs ?placeAuthorityURI  }
      }
        `,
    'migrationsQuery': `
      PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
      PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
      PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
      PREFIX wgs84: <http://www.w3.org/2003/01/geo/wgs84_pos#>
      PREFIX dct: <http://purl.org/dc/terms/>
      PREFIX owl: <http://www.w3.org/2002/07/owl#>
      PREFIX frbroo: <http://erlangen-crm.org/efrbroo/>
      PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
      PREFIX mmm-schema: <http://ldf.fi/mmm/schema/>
      SELECT DISTINCT ?id ?manuscript__id ?manuscript__url ?from__id ?from__name ?from__lat ?from__long ?to__id ?to__name ?to__lat ?to__long
      WHERE {
        # https://github.com/uber/deck.gl/blob/master/docs/layers/arc-layer.md
        ?manuscript__id ^crm:P108_has_produced/crm:P7_took_place_at ?from__id .
        ?manuscript__id mmm-schema:data_provider_url ?manuscript__url .
        ?from__id skos:prefLabel ?from__name .
        ?from__id wgs84:lat ?from__lat ;
                  wgs84:long ?from__long .
        ?event__id crm:P24_transferred_title_of|mmm-schema:observed_manuscript ?manuscript__id .
        OPTIONAL { ?event__id skos:prefLabel ?event__prefLabel }
        ?event__id crm:P4_has_time-span|mmm-schema:observed_time-span ?event__date .
        ?event__id crm:P7_took_place_at|mmm-schema:observed_location ?to__id .
        ?to__id skos:prefLabel ?to__name .
        ?to__id wgs84:lat ?to__lat ;
                wgs84:long ?to__long .
        BIND(IRI(CONCAT(STR(?from__id), "-", REPLACE(STR(?to__id), "http://ldf.fi/mmm/place/", ""))) as ?id)
        FILTER NOT EXISTS {
          ?event__id2 crm:P24_transferred_title_of ?manuscript__id .
          ?event__id2 crm:P4_has_time-span ?event__date2 .
          filter (?event__date2 > ?event__date)
        }
      }
        `,
    // http://vocab.getty.edu/doc/queries/#Places_by_Direct_and_Hierarchical_Type
    'placeQuery': `
      PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
      PREFIX wgs84: <http://www.w3.org/2003/01/geo/wgs84_pos#>
      PREFIX dct: <http://purl.org/dc/terms/>
      PREFIX owl: <http://www.w3.org/2002/07/owl#>
      PREFIX frbroo: <http://erlangen-crm.org/efrbroo/>
      PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
      PREFIX mmm-schema: <http://ldf.fi/mmm/schema/>
      PREFIX gvp: <http://vocab.getty.edu/ontology#>

      SELECT ?id ?prefLabel ?sameAs ?dataProviderUrl ?parent__id ?parent__prefLabel ?manuscript__id ?manuscript__dataProviderUrl
      WHERE {
        BIND (<PLACE_ID> AS ?id)
        ?id skos:prefLabel ?prefLabel .
        OPTIONAL {
          ?id gvp:broaderPreferred ?parent__id .
          ?parent__id skos:prefLabel ?parent__prefLabel .
        }
        OPTIONAL { ?id mmm-schema:data_provider_url ?dataProviderUrl }
        OPTIONAL { ?id owl:sameAs ?sameAs }
        OPTIONAL {
          ?manuscript__id ^crm:P108_has_produced/crm:P7_took_place_at ?id .
          ?manuscript__id mmm-schema:data_provider_url ?manuscript__dataProviderUrl .
          <FILTER>
        }
      }
        `,
    'facetQuery': `
      PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
      PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
      PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
      PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
      PREFIX owl: <http://www.w3.org/2002/07/owl#>
      PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
      PREFIX text: <http://jena.apache.org/text#>
      PREFIX dct: <http://purl.org/dc/terms/>
      PREFIX geo: <http://www.w3.org/2003/01/geo/wgs84_pos#>
      PREFIX sch: <http://schema.org/>
      PREFIX geosparql: <http://www.opengis.net/ont/geosparql#>
      PREFIX frbroo: <http://erlangen-crm.org/efrbroo/>
      PREFIX mmm-schema: <http://ldf.fi/mmm/schema/>
      PREFIX gvp: <http://vocab.getty.edu/ontology#>
      PREFIX wgs84: <http://www.w3.org/2003/01/geo/wgs84_pos#>
      SELECT DISTINCT ?id ?prefLabel ?selected ?source ?parent ?lat ?long ?instanceCount {
        {
          {
            SELECT DISTINCT (count(DISTINCT ?instance) as ?instanceCount) ?id ?selected ?source ?lat ?long ?parent {
              {
                ?instance a <RDF_TYPE> .
                <FILTER>
                ?instance <PREDICATE> ?id
                <SELECTED_VALUES>
                BIND(COALESCE(?selected_, false) as ?selected)
                OPTIONAL { ?id dct:source ?source }
                OPTIONAL { ?id gvp:broaderPreferred ?parent_ . }
                OPTIONAL {
                  ?id wgs84:lat ?lat ;
                      wgs84:long ?long .
                }
                BIND(COALESCE(?parent_, '0') as ?parent)
              }
              <PARENTS>
            }
            GROUP BY ?id ?selected ?source ?lat ?long ?parent
          }
          FILTER(BOUND(?id))
          OPTIONAL { ?id skos:prefLabel ?prefLabel_ }
          BIND(COALESCE(STR(?prefLabel_), STR(?id)) AS ?prefLabel)
        }
        UNION
        {
          {
            SELECT DISTINCT (count(DISTINCT ?instance) as ?instanceCount) {
              ?instance a <RDF_TYPE> .
              <FILTER>
              FILTER NOT EXISTS {
                ?instance <PREDICATE> ?value .
              }
            }
          }
          BIND(IRI("http://ldf.fi/MISSING_VALUE") AS ?id)
          BIND("Unknown" AS ?prefLabel)
          BIND('0' as ?parent)
        }
      }
      <ORDER_BY>
    `,
    'tgn': {
      // Getty LOD documentation:
      // http://vocab.getty.edu/queries#Places_by_Type
      // https://groups.google.com/forum/#!topic/gettyvocablod/r4wsSJyne84
      // https://confluence.ontotext.com/display/OWLIMv54/OWLIM-SE+Full-text+Search
      // http://vocab.getty.edu/queries#Combination_Full-Text_and_Exact_String_Match
      // http://vocab.getty.edu/doc/#TGN_Place_Types
      'title': 'The Getty Thesaurus of Geographic Names',
      'shortTitle': 'TGN',
      'timePeriod': '',
      'endpoint': 'http://vocab.getty.edu/sparql.json',
      'simpleSuggestionQuery':
        'SELECT+DISTINCT+?label+' +
        'WHERE+{' +
        '?s+a+skos:Concept;+' +
        'luc:term+"<QUERYTERM>*";+' +
        'skos:inScheme+tgn:;' +
        'gvp:prefLabelGVP/xl:literalForm+?lbl+.' +
        '+BIND(STR(?lbl)+AS+?label)' +
        'FILTER+(STRSTARTS(LCASE(?lbl),+"<QUERYTERM>"))' +
        '}' +
        'LIMIT+20',
      'resultQuery':
        'SELECT+?s+(COALESCE(?labelEn,?labelGVP)+AS+?label)+?typeLabel+?broaderAreaLabel+?source+?lat+?long+?markerColor' +
        'WHERE+{' +
        '?s+luc:term+"<QUERYTERM>";+' +
        'skos:inScheme+tgn:;+' +
        'gvp:placeTypePreferred+[gvp:prefLabelGVP+[xl:literalForm+?typeLabel;dct:language+gvp_lang:en]];+' +
        'gvp:parentStringAbbrev+?broaderAreaLabel+.+' +
        'OPTIONAL+{?s+xl:prefLabel+[xl:literalForm+?labelEn;+dct:language+gvp_lang:en]}+' +
        'OPTIONAL{?s+gvp:prefLabelGVP+[xl:literalForm?labelGVP]}+' +
        'OPTIONAL{?s+foaf:focus+?place+.+?place+wgs:lat+?lat;+wgs:long+?long}+' +
        'FILTER+EXISTS+{?s+xl:prefLabel/gvp:term+?term+.+FILTER+(LCASE(STR(?term))="<QUERYTERM>")}' +
        'BIND("TGN"+AS+?source)+' +
        'BIND("orange"+AS+?markerColor)+' +
        '}',
    },
  },
};
